"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RateLimiterComponent = void 0;
const tslib_1 = require("tslib");
const core_1 = require("@loopback/core");
const rest_1 = require("@loopback/rest");
const keys_1 = require("./keys");
const middleware_1 = require("./middleware");
const providers_1 = require("./providers");
let RateLimiterComponent = class RateLimiterComponent {
    constructor(ratelimitConfig) {
        var _a;
        this.ratelimitConfig = ratelimitConfig;
        this.bindings = [];
        this.providers = {
            [keys_1.RateLimitSecurityBindings.RATELIMIT_SECURITY_ACTION.key]: providers_1.RatelimitActionProvider,
            [keys_1.RateLimitSecurityBindings.DATASOURCEPROVIDER.key]: providers_1.RatelimitDatasourceProvider,
            [keys_1.RateLimitSecurityBindings.METADATA.key]: providers_1.RateLimitMetadataProvider,
        };
        this.bindings.push(core_1.Binding.bind(keys_1.RateLimitSecurityBindings.CONFIG.key).to(null));
        if ((_a = this.ratelimitConfig) === null || _a === void 0 ? void 0 : _a.RatelimitActionMiddleware) {
            this.bindings.push((0, rest_1.createMiddlewareBinding)(middleware_1.RatelimitMiddlewareProvider));
        }
    }
};
RateLimiterComponent = tslib_1.__decorate([
    tslib_1.__param(0, (0, core_1.inject)(keys_1.RateLimitSecurityBindings.RATELIMITCONFIG, { optional: true })),
    tslib_1.__metadata("design:paramtypes", [Object])
], RateLimiterComponent);
exports.RateLimiterComponent = RateLimiterComponent;
//# sourceMappingURL=component.js.map