/// <reference types="express" />
import { Provider } from '@loopback/core';
import { Getter } from '@loopback/repository';
import { Request, Response, RestApplication } from '@loopback/rest';
import * as RateLimit from 'express-rate-limit';
import { RateLimitAction, RateLimitMetadata, RateLimitOptions } from '../types';
export declare class RatelimitActionProvider implements Provider<RateLimitAction> {
    private readonly getDatastore;
    private readonly getMetadata;
    private readonly application;
    private readonly config?;
    constructor(getDatastore: Getter<RateLimit.Store>, getMetadata: Getter<RateLimitMetadata>, application: RestApplication, config?: RateLimitOptions | undefined);
    value(): RateLimitAction;
    action(request: Request, response: Response): Promise<void>;
}
